<?php
// phpcs:ignoreFile
/**
 * @file
 * A database agnostic dump for testing purposes.
 *
 * This file was generated by the Drupal 9.2.9 db-tools.php script.
 */

use Drupal\Core\Database\Database;

$connection = Database::getConnection();

$connection->schema()->createTable('menu_links', array(
  'fields' => array(
    'menu_name' => array(
      'type' => 'varchar',
      'not null' => TRUE,
      'length' => '32',
      'default' => '',
    ),
    'mlid' => array(
      'type' => 'serial',
      'not null' => TRUE,
      'size' => 'normal',
      'unsigned' => TRUE,
    ),
    'plid' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'link_path' => array(
      'type' => 'varchar',
      'not null' => TRUE,
      'length' => '255',
      'default' => '',
    ),
    'router_path' => array(
      'type' => 'varchar',
      'not null' => TRUE,
      'length' => '255',
      'default' => '',
    ),
    'link_title' => array(
      'type' => 'varchar',
      'not null' => TRUE,
      'length' => '255',
      'default' => '',
    ),
    'options' => array(
      'type' => 'blob',
      'not null' => FALSE,
      'size' => 'normal',
    ),
    'module' => array(
      'type' => 'varchar',
      'not null' => TRUE,
      'length' => '255',
      'default' => 'system',
    ),
    'hidden' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'small',
      'default' => '0',
    ),
    'external' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'small',
      'default' => '0',
    ),
    'has_children' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'small',
      'default' => '0',
    ),
    'expanded' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'small',
      'default' => '0',
    ),
    'weight' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
    ),
    'depth' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'small',
      'default' => '0',
    ),
    'customized' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'small',
      'default' => '0',
    ),
    'p1' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'p2' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'p3' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'p4' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'p5' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'p6' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'p7' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'p8' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'p9' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'normal',
      'default' => '0',
      'unsigned' => TRUE,
    ),
    'updated' => array(
      'type' => 'int',
      'not null' => TRUE,
      'size' => 'small',
      'default' => '0',
    ),
  ),
  'primary key' => array(
    'mlid',
  ),
  'indexes' => array(
    'path_menu' => array(
      array(
        'link_path',
        '128',
      ),
      'menu_name',
    ),
    'menu_plid_expand_child' => array(
      'menu_name',
      'plid',
      'expanded',
      'has_children',
    ),
    'menu_parents' => array(
      'menu_name',
      'p1',
      'p2',
      'p3',
      'p4',
      'p5',
      'p6',
      'p7',
      'p8',
      'p9',
    ),
    'router_path' => array(
      array(
        'router_path',
        '128',
      ),
    ),
  ),
  'mysql_character_set' => 'utf8',
));

$connection->insert('menu_links')
->fields(array(
  'menu_name',
  'mlid',
  'plid',
  'link_path',
  'router_path',
  'link_title',
  'options',
  'module',
  'hidden',
  'external',
  'has_children',
  'expanded',
  'weight',
  'depth',
  'customized',
  'p1',
  'p2',
  'p3',
  'p4',
  'p5',
  'p6',
  'p7',
  'p8',
  'p9',
  'updated',
))
->values(array(
  'menu_name' => 'shortcut-set-1',
  'mlid' => '216',
  'plid' => '0',
  'link_path' => 'node/add',
  'router_path' => 'node/add',
  'link_title' => 'Menu link mlid #216',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '1',
  'customized' => '0',
  'p1' => '216',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'shortcut-set-1',
  'mlid' => '217',
  'plid' => '0',
  'link_path' => 'admin/content',
  'router_path' => 'admin/content',
  'link_title' => 'Menu link mlid #217',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '1',
  'customized' => '0',
  'p1' => '217',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '669',
  'plid' => '0',
  'link_path' => 'node/801',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #669',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-48',
  'depth' => '1',
  'customized' => '1',
  'p1' => '669',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '678',
  'plid' => '2716',
  'link_path' => 'node/1290',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #678',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '678',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '680',
  'plid' => '2716',
  'link_path' => 'node/811',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #680',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '680',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '682',
  'plid' => '2716',
  'link_path' => 'node/816',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #682',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-42',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '682',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '690',
  'plid' => '0',
  'link_path' => 'node/850',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #690',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-47',
  'depth' => '1',
  'customized' => '1',
  'p1' => '690',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '697',
  'plid' => '0',
  'link_path' => 'node/851',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #697',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-46',
  'depth' => '1',
  'customized' => '1',
  'p1' => '697',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '700',
  'plid' => '697',
  'link_path' => 'node/1074',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #700',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-45',
  'depth' => '2',
  'customized' => '1',
  'p1' => '697',
  'p2' => '700',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '701',
  'plid' => '697',
  'link_path' => 'node/894',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #701',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '697',
  'p2' => '701',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '736',
  'plid' => '2716',
  'link_path' => 'node/837',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #736',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '1',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '736',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '773',
  'plid' => '678',
  'link_path' => 'node/1310',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #773',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '678',
  'p3' => '773',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '780',
  'plid' => '681',
  'link_path' => 'node/1046',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #780',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '681',
  'p3' => '780',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '786',
  'plid' => '682',
  'link_path' => 'node/865',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #786',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '682',
  'p3' => '786',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '818',
  'plid' => '690',
  'link_path' => 'node/1048',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #818',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '818',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '820',
  'plid' => '1184',
  'link_path' => '<void>',
  'router_path' => '<void>',
  'link_title' => 'Menu link mlid #820',
  'options' => 'a:1:{s:8:"external";i:1;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '3',
  'customized' => '1',
  'p1' => '690',
  'p2' => '1184',
  'p3' => '820',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '825',
  'plid' => '700',
  'link_path' => 'node/1263',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #825',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '700',
  'p3' => '825',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '827',
  'plid' => '700',
  'link_path' => 'node/884',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #827',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '700',
  'p3' => '827',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '828',
  'plid' => '700',
  'link_path' => 'node/888',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #828',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '700',
  'p3' => '828',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '850',
  'plid' => '690',
  'link_path' => 'node/2176',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #850',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-41',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '850',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'shortcut-set-1',
  'mlid' => '996',
  'plid' => '0',
  'link_path' => 'admin/structure/block/manage/rvcc_blocks/chat_with_an_advisor/configure?destination=node/96',
  'router_path' => 'admin/structure/block/manage/%/%',
  'link_title' => 'Menu link mlid #996',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '1',
  'customized' => '0',
  'p1' => '996',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '999',
  'plid' => '669',
  'link_path' => 'node/1252',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #999',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '999',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1000',
  'plid' => '669',
  'link_path' => 'node/1234',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1000',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '1000',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1001',
  'plid' => '669',
  'link_path' => 'node/1259',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1001',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '1001',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1002',
  'plid' => '669',
  'link_path' => 'node/1260',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1002',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '1002',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1003',
  'plid' => '669',
  'link_path' => 'node/1261',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1003',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '1003',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'shortcut-set-1',
  'mlid' => '1008',
  'plid' => '0',
  'link_path' => 'admin/config/user-interface/accordions',
  'router_path' => 'admin/config/user-interface',
  'link_title' => 'Menu link mlid #1008',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '1',
  'customized' => '0',
  'p1' => '1008',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1125',
  'plid' => '678',
  'link_path' => 'node/1290',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1125',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '678',
  'p3' => '1125',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1128',
  'plid' => '682',
  'link_path' => 'node/816',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1128',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '682',
  'p3' => '1128',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1130',
  'plid' => '669',
  'link_path' => 'node/801',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1130',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '1130',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1133',
  'plid' => '690',
  'link_path' => 'node/850',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1133',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '1133',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1139',
  'plid' => '1184',
  'link_path' => 'node/1186',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1139',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '690',
  'p2' => '1184',
  'p3' => '1139',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1140',
  'plid' => '697',
  'link_path' => 'node/851',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1140',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '697',
  'p2' => '1140',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1141',
  'plid' => '15451',
  'link_path' => '<void1>',
  'router_path' => '<void1>',
  'link_title' => 'Menu link mlid #1141',
  'options' => 'a:1:{s:8:"external";i:1;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '15451',
  'p3' => '1141',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1142',
  'plid' => '700',
  'link_path' => 'node/1074',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1142',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '700',
  'p3' => '1142',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1184',
  'plid' => '690',
  'link_path' => 'node/1186',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1184',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '0',
  'weight' => '-40',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '1184',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'shortcut-set-1',
  'mlid' => '1513',
  'plid' => '0',
  'link_path' => 'admin/structure/multifield/manage/field_alert_detail/fields?destination=admin/structure/types/manage/campus-alert/fields',
  'router_path' => 'admin/structure/multifield/manage/%',
  'link_title' => 'Menu link mlid #1513',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '1',
  'customized' => '0',
  'p1' => '1513',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1766',
  'plid' => '2716',
  'link_path' => 'node/821',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1766',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '1766',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1879',
  'plid' => '2716',
  'link_path' => 'node/849',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1879',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '1879',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1889',
  'plid' => '682',
  'link_path' => 'node/1311',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1889',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '682',
  'p3' => '1889',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1894',
  'plid' => '682',
  'link_path' => 'node/861',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1894',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '682',
  'p3' => '1894',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '1920',
  'plid' => '700',
  'link_path' => 'node/1204',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #1920',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-41',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '700',
  'p3' => '1920',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '2141',
  'plid' => '690',
  'link_path' => 'node/1025',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #2141',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '1',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '2141',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '2179',
  'plid' => '697',
  'link_path' => 'node/1266',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #2179',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '1',
  'p1' => '697',
  'p2' => '2179',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '2318',
  'plid' => '701',
  'link_path' => 'node/1205',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #2318',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '701',
  'p3' => '2318',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '2319',
  'plid' => '701',
  'link_path' => 'node/894',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #2319',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '701',
  'p3' => '2319',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '2505',
  'plid' => '669',
  'link_path' => 'node/1187',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #2505',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '2505',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '2716',
  'plid' => '0',
  'link_path' => 'node/2306',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #2716',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-50',
  'depth' => '1',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '2721',
  'plid' => '2716',
  'link_path' => 'node/2306',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #2721',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '2721',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '2741',
  'plid' => '669',
  'link_path' => 'node/2321',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #2741',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '2741',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3031',
  'plid' => '700',
  'link_path' => 'node/2866',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3031',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '700',
  'p3' => '3031',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3511',
  'plid' => '1766',
  'link_path' => 'node/3436',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3511',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '1766',
  'p3' => '3511',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3516',
  'plid' => '1766',
  'link_path' => 'node/3441',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3516',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '1766',
  'p3' => '3516',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3526',
  'plid' => '1766',
  'link_path' => 'node/821',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3526',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '1766',
  'p3' => '3526',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3551',
  'plid' => '700',
  'link_path' => 'node/3386',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3551',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '700',
  'p3' => '3551',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3591',
  'plid' => '690',
  'link_path' => 'node/22931',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3591',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-42',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '3591',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3601',
  'plid' => '3591',
  'link_path' => 'node/3641',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3601',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '1',
  'weight' => '-48',
  'depth' => '3',
  'customized' => '1',
  'p1' => '690',
  'p2' => '3591',
  'p3' => '3601',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3631',
  'plid' => '3591',
  'link_path' => 'node/23481',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3631',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '3',
  'customized' => '1',
  'p1' => '690',
  'p2' => '3591',
  'p3' => '3631',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3651',
  'plid' => '2716',
  'link_path' => 'node/858',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3651',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '3651',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '3656',
  'plid' => '2716',
  'link_path' => 'node/1302',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #3656',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '1',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '3656',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '4026',
  'plid' => '1184',
  'link_path' => 'node/4411',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #4026',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '690',
  'p2' => '1184',
  'p3' => '4026',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '4036',
  'plid' => '682',
  'link_path' => 'node/4451',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #4036',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-40',
  'depth' => '3',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '682',
  'p3' => '4036',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '4261',
  'plid' => '669',
  'link_path' => 'node/3741',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #4261',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '669',
  'p2' => '4261',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '7196',
  'plid' => '2716',
  'link_path' => 'node/7361',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #7196',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '1',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '7196',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-other-menu',
  'mlid' => '10046',
  'plid' => '0',
  'link_path' => '<void>',
  'router_path' => '<void>',
  'link_title' => 'Menu link mlid #10046',
  'options' => 'a:1:{s:8:"external";i:1;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '1',
  'p1' => '10046',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '11541',
  'plid' => '2716',
  'link_path' => 'node/12736',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #11541',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '1',
  'weight' => '-40',
  'depth' => '2',
  'customized' => '1',
  'p1' => '2716',
  'p2' => '11541',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '13771',
  'plid' => '19781',
  'link_path' => 'node/14966',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #13771',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '4',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '19781',
  'p3' => '13771',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '15451',
  'plid' => '697',
  'link_path' => 'http://www.exampe.com/foo/bar',
  'router_path' => '',
  'link_title' => 'Menu link mlid #15451',
  'options' => 'a:1:{s:8:"external";i:1;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '1',
  'has_children' => '1',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '697',
  'p2' => '15451',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '16271',
  'plid' => '669',
  'link_path' => 'node/19502',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #16271',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '2',
  'customized' => '1',
  'p1' => '669',
  'p2' => '16271',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '16276',
  'plid' => '669',
  'link_path' => 'node/19281',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #16276',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-19',
  'depth' => '2',
  'customized' => '0',
  'p1' => '669',
  'p2' => '16276',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '16971',
  'plid' => '3591',
  'link_path' => 'node/22931',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #16971',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '3',
  'customized' => '1',
  'p1' => '690',
  'p2' => '3591',
  'p3' => '16971',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '17806',
  'plid' => '682',
  'link_path' => 'node/22186',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #17806',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '3',
  'customized' => '0',
  'p1' => '2716',
  'p2' => '682',
  'p3' => '17806',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '19781',
  'plid' => '697',
  'link_path' => 'https://www.exampe.com/bar/baz',
  'router_path' => '',
  'link_title' => 'Menu link mlid #19781',
  'options' => 'a:1:{s:8:"external";i:1;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '1',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-44',
  'depth' => '2',
  'customized' => '1',
  'p1' => '697',
  'p2' => '19781',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '19791',
  'plid' => '19781',
  'link_path' => 'node/28896',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #19791',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '2',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '19781',
  'p3' => '19791',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '20606',
  'plid' => '19781',
  'link_path' => 'node/29891',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #20606',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '1',
  'weight' => '-46',
  'depth' => '3',
  'customized' => '1',
  'p1' => '697',
  'p2' => '19781',
  'p3' => '20606',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '23266',
  'plid' => '690',
  'link_path' => 'node/34946',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #23266',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '23266',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '24116',
  'plid' => '690',
  'link_path' => 'node/37336',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #24116',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '1',
  'weight' => '-44',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '24116',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '24501',
  'plid' => '690',
  'link_path' => 'node/37226',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #24501',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '2',
  'customized' => '1',
  'p1' => '690',
  'p2' => '24501',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '24941',
  'plid' => '690',
  'link_path' => 'node/37871',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #24941',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '50',
  'depth' => '2',
  'customized' => '0',
  'p1' => '690',
  'p2' => '24941',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25011',
  'plid' => '0',
  'link_path' => 'node/821',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25011',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-48',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25011',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25016',
  'plid' => '25011',
  'link_path' => 'node/3441',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25016',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25011',
  'p2' => '25016',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25021',
  'plid' => '25011',
  'link_path' => 'node/3436',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25021',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25011',
  'p2' => '25021',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25026',
  'plid' => '0',
  'link_path' => 'node/1290',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25026',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-47',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25026',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25046',
  'plid' => '25026',
  'link_path' => 'node/1310',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25046',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25026',
  'p2' => '25046',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25071',
  'plid' => '30216',
  'link_path' => 'node/12736',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25071',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '25071',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25101',
  'plid' => '0',
  'link_path' => 'node/849',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25101',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25101',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25106',
  'plid' => '0',
  'link_path' => 'node/811',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25106',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25106',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25111',
  'plid' => '0',
  'link_path' => 'node/816',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25111',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-42',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25111',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25116',
  'plid' => '25111',
  'link_path' => 'node/861',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25116',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25111',
  'p2' => '25116',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25121',
  'plid' => '25111',
  'link_path' => 'node/1311',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25121',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25111',
  'p2' => '25121',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25126',
  'plid' => '25111',
  'link_path' => 'node/865',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25126',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25111',
  'p2' => '25126',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25131',
  'plid' => '25111',
  'link_path' => 'node/22186',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25131',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25111',
  'p2' => '25131',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25146',
  'plid' => '25111',
  'link_path' => 'node/4451',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25146',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25111',
  'p2' => '25146',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '25156',
  'plid' => '30221',
  'link_path' => 'node/1252',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25156',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '25156',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '25161',
  'plid' => '30221',
  'link_path' => 'node/1234',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25161',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '25161',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '25166',
  'plid' => '30221',
  'link_path' => 'node/1259',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25166',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '25166',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '25171',
  'plid' => '30221',
  'link_path' => 'node/1261',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25171',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '25171',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '25176',
  'plid' => '30221',
  'link_path' => 'node/2321',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25176',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '25176',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '25181',
  'plid' => '30221',
  'link_path' => 'node/19502',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25181',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '25181',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '25186',
  'plid' => '30221',
  'link_path' => 'node/19281',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25186',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '25186',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '25201',
  'plid' => '0',
  'link_path' => 'node/1187',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25201',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-39',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25201',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '25216',
  'plid' => '0',
  'link_path' => 'node/34946',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25216',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-7',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25216',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '25226',
  'plid' => '0',
  'link_path' => 'node/1025',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25226',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-4',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25226',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '25231',
  'plid' => '0',
  'link_path' => 'node/37336',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25231',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-3',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25231',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '25246',
  'plid' => '0',
  'link_path' => 'node/22931',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25246',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '1',
  'weight' => '1',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25246',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '25256',
  'plid' => '26796',
  'link_path' => 'node/23481',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25256',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '1',
  'depth' => '2',
  'customized' => '1',
  'p1' => '26796',
  'p2' => '25256',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '25266',
  'plid' => '0',
  'link_path' => 'node/2176',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25266',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25266',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '25271',
  'plid' => '0',
  'link_path' => 'node/1186',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25271',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-5',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25271',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25276',
  'plid' => '0',
  'link_path' => 'node/3641',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25276',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25276',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25281',
  'plid' => '0',
  'link_path' => 'node/1262',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25281',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-10',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25281',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25291',
  'plid' => '0',
  'link_path' => 'node/1266',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25291',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-8',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25291',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25296',
  'plid' => '0',
  'link_path' => 'node/894',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25296',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-7',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25296',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25301',
  'plid' => '25296',
  'link_path' => 'node/1205',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25301',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25296',
  'p2' => '25301',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25306',
  'plid' => '0',
  'link_path' => 'node/1074',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25306',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-6',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25306',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25311',
  'plid' => '25306',
  'link_path' => 'node/1263',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25311',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-7',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25306',
  'p2' => '25311',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25316',
  'plid' => '25306',
  'link_path' => 'node/2866',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25316',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-6',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25306',
  'p2' => '25316',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25321',
  'plid' => '25306',
  'link_path' => 'node/3386',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25321',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-5',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25306',
  'p2' => '25321',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25326',
  'plid' => '25306',
  'link_path' => 'node/884',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25326',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-3',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25306',
  'p2' => '25326',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25331',
  'plid' => '25306',
  'link_path' => 'node/888',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25331',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-2',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25306',
  'p2' => '25331',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25341',
  'plid' => '25306',
  'link_path' => 'node/1204',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25341',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25306',
  'p2' => '25341',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25351',
  'plid' => '30156',
  'link_path' => 'node/29891',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25351',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30156',
  'p2' => '25351',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25356',
  'plid' => '30156',
  'link_path' => 'node/28896',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25356',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30156',
  'p2' => '25356',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25366',
  'plid' => '30156',
  'link_path' => 'node/14966',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25366',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30156',
  'p2' => '25366',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25391',
  'plid' => '30226',
  'link_path' => 'node/908',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25391',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30226',
  'p2' => '25391',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25396',
  'plid' => '30226',
  'link_path' => 'node/909',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25396',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30226',
  'p2' => '25396',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25401',
  'plid' => '30226',
  'link_path' => 'node/905',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25401',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30226',
  'p2' => '25401',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25416',
  'plid' => '0',
  'link_path' => 'node/1082',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25416',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25416',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25431',
  'plid' => '30236',
  'link_path' => 'node/3241',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25431',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '25431',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25436',
  'plid' => '30236',
  'link_path' => 'node/920',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25436',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '25436',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25441',
  'plid' => '30236',
  'link_path' => 'node/2181',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25441',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '25441',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25451',
  'plid' => '30236',
  'link_path' => 'node/2191',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25451',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '25451',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25456',
  'plid' => '30236',
  'link_path' => 'node/924',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25456',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '25456',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25461',
  'plid' => '30236',
  'link_path' => 'node/2186',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25461',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '25461',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25466',
  'plid' => '30236',
  'link_path' => 'node/922',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25466',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '25466',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25476',
  'plid' => '0',
  'link_path' => 'node/915',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25476',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-35',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25476',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25491',
  'plid' => '0',
  'link_path' => 'node/24406',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25491',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-32',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25491',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25496',
  'plid' => '0',
  'link_path' => 'node/925',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25496',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-49',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25501',
  'plid' => '25496',
  'link_path' => 'node/13531',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25501',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-10',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '25501',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25506',
  'plid' => '25496',
  'link_path' => 'node/1295',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25506',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '1',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '25506',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25511',
  'plid' => '25496',
  'link_path' => 'node/151',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25511',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '2',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '25511',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25516',
  'plid' => '25496',
  'link_path' => 'node/1293',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25516',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '2',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '25516',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25521',
  'plid' => '25496',
  'link_path' => 'node/8686',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25521',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '4',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '25521',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25526',
  'plid' => '25496',
  'link_path' => 'node/13521',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25526',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '5',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '25526',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25536',
  'plid' => '25496',
  'link_path' => 'node/926',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25536',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '10',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '25536',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25551',
  'plid' => '0',
  'link_path' => 'node/929',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25551',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-50',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25551',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25556',
  'plid' => '25551',
  'link_path' => 'node/146',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25556',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-5',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25551',
  'p2' => '25556',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25566',
  'plid' => '25551',
  'link_path' => 'node/2796',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25566',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-3',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25551',
  'p2' => '25566',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25601',
  'plid' => '27706',
  'link_path' => 'node/941',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25601',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '27706',
  'p2' => '25601',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25606',
  'plid' => '0',
  'link_path' => 'node/942',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25606',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-7',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25606',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25611',
  'plid' => '0',
  'link_path' => 'node/8241',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25611',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-6',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25611',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25616',
  'plid' => '0',
  'link_path' => 'node/2946',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25616',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25616',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25621',
  'plid' => '0',
  'link_path' => 'node/23256',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25621',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25621',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25626',
  'plid' => '0',
  'link_path' => 'node/944',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25626',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-39',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25626',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25631',
  'plid' => '0',
  'link_path' => 'node/947',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25631',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25631',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25636',
  'plid' => '0',
  'link_path' => 'node/949',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25636',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25636',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25641',
  'plid' => '0',
  'link_path' => 'node/1299',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25641',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-42',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25641',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '25646',
  'plid' => '25641',
  'link_path' => 'node/2726',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25646',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25641',
  'p2' => '25646',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25676',
  'plid' => '0',
  'link_path' => 'node/24591',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25676',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-8',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25676',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25681',
  'plid' => '0',
  'link_path' => 'node/24611',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25681',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-7',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25681',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25686',
  'plid' => '0',
  'link_path' => 'node/24616',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25686',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-6',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25686',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25691',
  'plid' => '0',
  'link_path' => 'node/24641',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25691',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-5',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25691',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '25701',
  'plid' => '0',
  'link_path' => 'node/24716',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25701',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25701',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-business-resources-menu',
  'mlid' => '25711',
  'plid' => '0',
  'link_path' => 'node/1005',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25711',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-3',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25711',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-business-resources-menu',
  'mlid' => '25716',
  'plid' => '0',
  'link_path' => 'node/1008',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25716',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-2',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25716',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-business-resources-menu',
  'mlid' => '25721',
  'plid' => '0',
  'link_path' => 'node/5031',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25721',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-1',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25721',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25731',
  'plid' => '0',
  'link_path' => 'node/487',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25731',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-50',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25731',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25736',
  'plid' => '25731',
  'link_path' => 'node/1302',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25736',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25731',
  'p2' => '25736',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25746',
  'plid' => '25731',
  'link_path' => 'node/1141',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25746',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '1',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25731',
  'p2' => '25746',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25756',
  'plid' => '30241',
  'link_path' => 'node/35211',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25756',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30241',
  'p2' => '25756',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25761',
  'plid' => '30241',
  'link_path' => 'node/1286',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25761',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30241',
  'p2' => '25761',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25766',
  'plid' => '0',
  'link_path' => 'node/1121',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25766',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-46',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25766',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25776',
  'plid' => '0',
  'link_path' => 'node/1246',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25776',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-45',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25776',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25806',
  'plid' => '0',
  'link_path' => 'node/922',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25806',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25806',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25811',
  'plid' => '0',
  'link_path' => 'node/1146',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25811',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-42',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25811',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25836',
  'plid' => '25811',
  'link_path' => 'https://www.example.com/sites/default/files/PDF-files/exampe.pdf',
  'router_path' => '',
  'link_title' => 'Menu link mlid #25836',
  'options' => 'a:1:{s:8:"external";i:1;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '1',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25811',
  'p2' => '25836',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25841',
  'plid' => '25811',
  'link_path' => 'node/2721',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25841',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '1',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25811',
  'p2' => '25841',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25846',
  'plid' => '25811',
  'link_path' => 'node/15776',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25846',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '2',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25811',
  'p2' => '25846',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25856',
  'plid' => '25811',
  'link_path' => 'node/9656',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25856',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '4',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25811',
  'p2' => '25856',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25861',
  'plid' => '25811',
  'link_path' => 'node/7471',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25861',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '5',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25811',
  'p2' => '25861',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25886',
  'plid' => '0',
  'link_path' => 'node/9066',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25886',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-38',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25886',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25891',
  'plid' => '0',
  'link_path' => 'node/1029',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25891',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25891',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '25896',
  'plid' => '25306',
  'link_path' => 'node/38656',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25896',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-5',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25306',
  'p2' => '25896',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '25926',
  'plid' => '0',
  'link_path' => 'node/26556',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25926',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25926',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '25941',
  'plid' => '0',
  'link_path' => 'node/1114',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25941',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25941',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '25946',
  'plid' => '0',
  'link_path' => 'https://baz.exampe.com/',
  'router_path' => '',
  'link_title' => 'Menu link mlid #25946',
  'options' => 'a:1:{s:8:"external";i:1;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '1',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25946',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '25951',
  'plid' => '0',
  'link_path' => '<void1>',
  'router_path' => '<void1>',
  'link_title' => 'Menu link mlid #25951',
  'options' => 'a:1:{s:8:"external";i:1;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25951',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '25966',
  'plid' => '0',
  'link_path' => 'node/6501',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25966',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-39',
  'depth' => '1',
  'customized' => '1',
  'p1' => '25966',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '25981',
  'plid' => '0',
  'link_path' => 'node/10226',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25981',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '0',
  'p1' => '25981',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'main-menu',
  'mlid' => '25986',
  'plid' => '0',
  'link_path' => 'node/39856',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25986',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '0',
  'p1' => '25986',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25991',
  'plid' => '30226',
  'link_path' => 'node/39791',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25991',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30226',
  'p2' => '25991',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '25996',
  'plid' => '30236',
  'link_path' => 'node/39856',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #25996',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '25996',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '26756',
  'plid' => '0',
  'link_path' => 'node/10226',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #26756',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-30',
  'depth' => '1',
  'customized' => '1',
  'p1' => '26756',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '26761',
  'plid' => '25011',
  'link_path' => 'node/37226',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #26761',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '50',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25011',
  'p2' => '26761',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '26766',
  'plid' => '0',
  'link_path' => 'node/40341',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #26766',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-41',
  'depth' => '1',
  'customized' => '1',
  'p1' => '26766',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '26781',
  'plid' => '0',
  'link_path' => 'node/3956',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #26781',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '10',
  'depth' => '1',
  'customized' => '0',
  'p1' => '26781',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '26796',
  'plid' => '0',
  'link_path' => 'node/40656',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #26796',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '0',
  'weight' => '9',
  'depth' => '1',
  'customized' => '0',
  'p1' => '26796',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '26801',
  'plid' => '26796',
  'link_path' => 'node/23746',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #26801',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '2',
  'depth' => '2',
  'customized' => '0',
  'p1' => '26796',
  'p2' => '26801',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '26816',
  'plid' => '0',
  'link_path' => 'node/40731',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #26816',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '1',
  'customized' => '1',
  'p1' => '26816',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '26831',
  'plid' => '25496',
  'link_path' => 'node/40921',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #26831',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '1',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '26831',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '27221',
  'plid' => '0',
  'link_path' => 'node/41096',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27221',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '0',
  'p1' => '27221',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '27241',
  'plid' => '25496',
  'link_path' => 'node/41201',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27241',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '1',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '27241',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '27631',
  'plid' => '30221',
  'link_path' => 'node/41341',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27631',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '27631',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '27646',
  'plid' => '0',
  'link_path' => 'node/24581',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27646',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '1',
  'customized' => '1',
  'p1' => '27646',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '27651',
  'plid' => '0',
  'link_path' => 'node/41146',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27651',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '1',
  'customized' => '1',
  'p1' => '27651',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '27686',
  'plid' => '0',
  'link_path' => 'node/41736',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27686',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-41',
  'depth' => '1',
  'customized' => '1',
  'p1' => '27686',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '27691',
  'plid' => '0',
  'link_path' => 'node/2191',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27691',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-38',
  'depth' => '1',
  'customized' => '1',
  'p1' => '27691',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '27696',
  'plid' => '0',
  'link_path' => 'node/40731',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27696',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '1',
  'customized' => '1',
  'p1' => '27696',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '27706',
  'plid' => '0',
  'link_path' => 'node/41901',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27706',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-46',
  'depth' => '1',
  'customized' => '1',
  'p1' => '27706',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '27711',
  'plid' => '27706',
  'link_path' => 'node/41906',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27711',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '27706',
  'p2' => '27711',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '27716',
  'plid' => '27706',
  'link_path' => 'node/41981',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27716',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-7',
  'depth' => '2',
  'customized' => '1',
  'p1' => '27706',
  'p2' => '27716',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '27721',
  'plid' => '0',
  'link_path' => 'node/41986',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27721',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-7',
  'depth' => '1',
  'customized' => '1',
  'p1' => '27721',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '27726',
  'plid' => '25496',
  'link_path' => 'node/1298',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27726',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25496',
  'p2' => '27726',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '27746',
  'plid' => '25496',
  'link_path' => 'node/42051',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27746',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '3',
  'depth' => '2',
  'customized' => '1',
  'p1' => '25496',
  'p2' => '27746',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '27751',
  'plid' => '30216',
  'link_path' => 'node/41826',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #27751',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '27751',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '29391',
  'plid' => '0',
  'link_path' => 'node/42176',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29391',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-40',
  'depth' => '1',
  'customized' => '1',
  'p1' => '29391',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '29571',
  'plid' => '25111',
  'link_path' => 'node/42986',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29571',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25111',
  'p2' => '29571',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '29581',
  'plid' => '0',
  'link_path' => 'node/42966',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29581',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '1',
  'customized' => '1',
  'p1' => '29581',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '29591',
  'plid' => '0',
  'link_path' => 'node/42966',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29591',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-2',
  'depth' => '1',
  'customized' => '1',
  'p1' => '29591',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '29596',
  'plid' => '29581',
  'link_path' => 'node/43001',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29596',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '29581',
  'p2' => '29596',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '29601',
  'plid' => '29581',
  'link_path' => 'node/42991',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29601',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '29581',
  'p2' => '29601',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '29606',
  'plid' => '29581',
  'link_path' => 'node/43006',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29606',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '29581',
  'p2' => '29606',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '29611',
  'plid' => '29581',
  'link_path' => 'node/43011',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29611',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '29581',
  'p2' => '29611',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '29616',
  'plid' => '29581',
  'link_path' => 'node/43016',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29616',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '29581',
  'p2' => '29616',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '29621',
  'plid' => '29581',
  'link_path' => 'node/43021',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29621',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '29581',
  'p2' => '29621',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '29626',
  'plid' => '29581',
  'link_path' => 'node/43026',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29626',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '1',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '1',
  'p1' => '29581',
  'p2' => '29626',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '29631',
  'plid' => '30156',
  'link_path' => 'node/43121',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29631',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30156',
  'p2' => '29631',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '29637',
  'plid' => '0',
  'link_path' => 'node/43147',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29637',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-9',
  'depth' => '1',
  'customized' => '0',
  'p1' => '29637',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '29642',
  'plid' => '0',
  'link_path' => 'node/43152',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #29642',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '0',
  'p1' => '29642',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30021',
  'plid' => '0',
  'link_path' => 'node/43211',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30021',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-41',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30021',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30026',
  'plid' => '30216',
  'link_path' => 'node/43236',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30026',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-41',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30026',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30031',
  'plid' => '30216',
  'link_path' => 'node/43241',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30031',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30031',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30036',
  'plid' => '30216',
  'link_path' => 'node/43246',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30036',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-42',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30036',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30041',
  'plid' => '30216',
  'link_path' => 'node/43251',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30041',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-43',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30041',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30046',
  'plid' => '30216',
  'link_path' => 'node/43256',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30046',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30046',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30051',
  'plid' => '30216',
  'link_path' => 'node/43261',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30051',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30051',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30056',
  'plid' => '30216',
  'link_path' => 'node/43266',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30056',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30056',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30061',
  'plid' => '30216',
  'link_path' => 'node/43271',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30061',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30061',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30066',
  'plid' => '25111',
  'link_path' => 'node/43276',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30066',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25111',
  'p2' => '30066',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30071',
  'plid' => '25026',
  'link_path' => 'node/43281',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30071',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25026',
  'p2' => '30071',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30076',
  'plid' => '25026',
  'link_path' => 'node/43286',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30076',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25026',
  'p2' => '30076',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30081',
  'plid' => '30216',
  'link_path' => 'node/43291',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30081',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-40',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '30081',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30086',
  'plid' => '25026',
  'link_path' => 'node/43296',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30086',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25026',
  'p2' => '30086',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-super-menu',
  'mlid' => '30091',
  'plid' => '0',
  'link_path' => 'node/43211',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30091',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30091',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30096',
  'plid' => '0',
  'link_path' => 'node/2226',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30096',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-31',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30096',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30101',
  'plid' => '0',
  'link_path' => 'node/43311',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30101',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-36',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30101',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30106',
  'plid' => '25776',
  'link_path' => 'node/43316',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30106',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25776',
  'p2' => '30106',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30111',
  'plid' => '25776',
  'link_path' => 'node/43321',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30111',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-4',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25776',
  'p2' => '30111',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-business-resources-menu',
  'mlid' => '30116',
  'plid' => '0',
  'link_path' => 'node/43326',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30116',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-4',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30116',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30121',
  'plid' => '0',
  'link_path' => 'node/43331',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30121',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30121',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30136',
  'plid' => '0',
  'link_path' => 'node/43346',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30136',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-9',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30136',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30141',
  'plid' => '25731',
  'link_path' => 'node/43356',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30141',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25731',
  'p2' => '30141',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30151',
  'plid' => '30226',
  'link_path' => 'node/43366',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30151',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-46',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30226',
  'p2' => '30151',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '30156',
  'plid' => '0',
  'link_path' => 'node/43371',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30156',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-5',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30156',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30161',
  'plid' => '25776',
  'link_path' => 'node/43381',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30161',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-2',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25776',
  'p2' => '30161',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30166',
  'plid' => '25766',
  'link_path' => 'node/43386',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30166',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25766',
  'p2' => '30166',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '30181',
  'plid' => '0',
  'link_path' => 'node/43401',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30181',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-38',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30181',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30186',
  'plid' => '0',
  'link_path' => 'node/43406',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30186',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-44',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30186',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30196',
  'plid' => '0',
  'link_path' => 'node/43426',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30196',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-4',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30196',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '30201',
  'plid' => '0',
  'link_path' => 'node/43431',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30201',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '4',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30201',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '30211',
  'plid' => '0',
  'link_path' => 'node/43186',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30211',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30211',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30216',
  'plid' => '0',
  'link_path' => 'node/43436',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30216',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-46',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30216',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-career-training-menu',
  'mlid' => '30221',
  'plid' => '0',
  'link_path' => 'node/43421',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30221',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-50',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30221',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30226',
  'plid' => '0',
  'link_path' => 'node/43391',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30226',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-48',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30226',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30236',
  'plid' => '0',
  'link_path' => 'node/43396',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30236',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-45',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30236',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30241',
  'plid' => '0',
  'link_path' => 'node/43336',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30241',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-49',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30241',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30246',
  'plid' => '0',
  'link_path' => 'node/43606',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30246',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-40',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30246',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30251',
  'plid' => '0',
  'link_path' => 'node/43361',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30251',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '1',
  'expanded' => '1',
  'weight' => '-49',
  'depth' => '1',
  'customized' => '1',
  'p1' => '30251',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30256',
  'plid' => '30251',
  'link_path' => 'node/837',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30256',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-50',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30251',
  'p2' => '30256',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30261',
  'plid' => '30251',
  'link_path' => 'node/858',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30261',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-49',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30251',
  'p2' => '30261',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30266',
  'plid' => '30251',
  'link_path' => 'node/1302',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30266',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-48',
  'depth' => '2',
  'customized' => '1',
  'p1' => '30251',
  'p2' => '30266',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30371',
  'plid' => '25776',
  'link_path' => 'node/43616',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30371',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-3',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25776',
  'p2' => '30371',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-business-resources-menu',
  'mlid' => '30376',
  'plid' => '0',
  'link_path' => 'node/43621',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30376',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30376',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30381',
  'plid' => '25811',
  'link_path' => 'node/43636',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30381',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '3',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25811',
  'p2' => '30381',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '30386',
  'plid' => '25641',
  'link_path' => 'node/43641',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30386',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25641',
  'p2' => '30386',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30391',
  'plid' => '25811',
  'link_path' => 'node/43646',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30391',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '6',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25811',
  'p2' => '30391',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30396',
  'plid' => '0',
  'link_path' => 'node/43651',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30396',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-33',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30396',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30401',
  'plid' => '25811',
  'link_path' => 'node/43656',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30401',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-3',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25811',
  'p2' => '30401',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30406',
  'plid' => '0',
  'link_path' => 'node/43666',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30406',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-45',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30406',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '30411',
  'plid' => '0',
  'link_path' => 'node/43681',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30411',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30411',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '30416',
  'plid' => '0',
  'link_path' => 'node/43686',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30416',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-40',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30416',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30421',
  'plid' => '25811',
  'link_path' => 'node/43691',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30421',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-1',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25811',
  'p2' => '30421',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30426',
  'plid' => '0',
  'link_path' => 'node/43696',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30426',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-34',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30426',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-paying-for-college-menu',
  'mlid' => '30431',
  'plid' => '25306',
  'link_path' => 'node/43716',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30431',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-1',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25306',
  'p2' => '30431',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-community-resources-menu',
  'mlid' => '30436',
  'plid' => '25641',
  'link_path' => 'node/43721',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30436',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '0',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25641',
  'p2' => '30436',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-general-information-menu',
  'mlid' => '30441',
  'plid' => '25811',
  'link_path' => 'node/43736',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30441',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-2',
  'depth' => '2',
  'customized' => '0',
  'p1' => '25811',
  'p2' => '30441',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30446',
  'plid' => '30226',
  'link_path' => 'node/43741',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30446',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '0',
  'p1' => '30226',
  'p2' => '30446',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-student-life-menu',
  'mlid' => '30451',
  'plid' => '0',
  'link_path' => 'node/43746',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30451',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-40',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30451',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-academic-programs-menu',
  'mlid' => '30456',
  'plid' => '30251',
  'link_path' => 'node/43751',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30456',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-47',
  'depth' => '2',
  'customized' => '0',
  'p1' => '30251',
  'p2' => '30456',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->values(array(
  'menu_name' => 'menu-admissions-information-menu',
  'mlid' => '30466',
  'plid' => '0',
  'link_path' => 'node/43456',
  'router_path' => 'node/%',
  'link_title' => 'Menu link mlid #30466',
  'options' => 'a:1:{s:8:"external";i:0;}',
  'module' => 'menu',
  'hidden' => '0',
  'external' => '0',
  'has_children' => '0',
  'expanded' => '0',
  'weight' => '-6',
  'depth' => '1',
  'customized' => '0',
  'p1' => '30466',
  'p2' => '0',
  'p3' => '0',
  'p4' => '0',
  'p5' => '0',
  'p6' => '0',
  'p7' => '0',
  'p8' => '0',
  'p9' => '0',
  'updated' => '0',
))
->execute();
